/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8350_SUPVIE_PRODACOMPRAR.SQL                                        */
/*                                                                            */
/* Descrio:                                                                 */
/* Agrupa todos os produtos a comprar solicitados (Solicitacao Compras)       */
/* e que ainda no possuem foram atendidos (AF).                              */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/* Manutenes:                                                               */
/*  19/05/2000 - Adriano de Arajo  Converso para SqlServer                  */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\ORACLE\8350_SUPVIE_PRODACOMPRAR.SQL                   */
/* @D:\SQLManut\ORACLE\8350_SUPVIE_PRODACOMPRAR.SQL                           */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8350_SUPVIE_PRODACOMPRAR.SQL                           */
/******************************************************************************/


CREATE OR REPLACE VIEW PRODACOMPRAR AS
SELECT
   COMP.CDFILIAL, COMP.DTPROGENTR,
   COMP.CDPRODUTO,
   CASE WHEN PARASUPRI.IDCONSPRSOL = 'N' THEN ROUND(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP/COMP.VRFATOCONV,0), 5)
   WHEN PARASUPRI.IDCONSPRSOL IS NULL THEN ROUND(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP/COMP.VRFATOCONV,0), 5)
   WHEN PARASUPRI.IDCONSPRSOL = 'S'  THEN ROUND(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP,0), 5)
   END QTACOMPRAR
FROM
   PARASUPRI,
   FILIAL,
   (SELECT
     ITEMSOLI.CDFILSOLI AS CDFILIAL,
     ITEMSOLI.DTPROGENTR,
     ITEMSOLI.CDPRODUTO,
     PRODUTO.CDPRODESTO,
     PRODUTO.VRFATOCONV,
     SUM(ITEMSOLI.QTSOLIPROD) AS QTDECOMP
    FROM
     PRODUTO, ITEMSOLI
    WHERE
     (ITEMSOLI.IDITMCONS = 'N') AND
     (ITEMSOLI.CDPRODUTO = PRODUTO.CDPRODUTO) AND
     (NVL(ITEMSOLI.IDSOLIAPROV,'S') = 'S')
    GROUP BY
     ITEMSOLI.CDFILSOLI,
     ITEMSOLI.DTPROGENTR,
     PRODUTO.CDPRODESTO,
     ITEMSOLI.CDPRODUTO,
     PRODUTO.VRFATOCONV) COMP,
   (SELECT
     ITEMAUTF.CDFILDEST AS CDFILIAL,
     ITEMAUTF.DTENTRITMSOL,
     PRODUTO.CDPRODESTO,
     SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) AS QTDECOMP
    FROM
     PRODUTO, ITEMAUTF, AUTOFORNE
    WHERE
    (AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST) AND
    (AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC) AND
    (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN) AND
    (ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO) AND
    (AUTOFORNE.IDSITUATUAAF IS NULL) AND
    (AUTOFORNE.IDAFFORALIM = 'N') AND
    (AUTOFORNE.IDAUTOFORNEX = 'N') AND
    (NVL(AUTOFORNE.IDBAIXAAF,'0') <> '5')
   GROUP BY
    ITEMAUTF.CDFILDEST,
    ITEMAUTF.DTENTRITMSOL,
    PRODUTO.CDPRODESTO) JACOMP
WHERE FILIAL.CDFILIAL = COMP.CDFILIAL
  AND PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
  AND COMP.CDFILIAL = JACOMP.CDFILIAL(+)
  AND COMP.DTPROGENTR = JACOMP.DTENTRITMSOL(+)
  AND COMP.CDPRODESTO = JACOMP.CDPRODESTO(+)
  AND ROUND(COMP.QTDECOMP-NVL(JACOMP.QTDECOMP/COMP.VRFATOCONV,0), 5) > 0
/

-- VERSAO --
BEGIN ATUVEROBJ('PRODACOMPRAR','5.05.001'); END;
/

